/*
 * Խػ! - ΥեGladeˤäƤޤ.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"

GtkWidget*
create_mainwin ()
{
  GtkWidget *mainwin;
  GtkWidget *vbox1;
  GtkWidget *filemenu;
  GtkWidget *item1;
  GtkWidget *item1_menu;
  GtkAccelGroup *item1_menu_accels;
  GtkWidget *gamequit;
  GtkWidget *petal1;
  GtkWidget *petal1_menu;
  GtkAccelGroup *petal1_menu_accels;
  GtkWidget *_10;
  GtkWidget *_25;
  GtkWidget *_50;
  GtkWidget *_100;
  GtkWidget *position1;
  GtkWidget *position1_menu;
  GtkAccelGroup *position1_menu_accels;
  GtkWidget *right1;
  GtkWidget *left1;
  GtkWidget *message1;
  GtkWidget *message1_menu;
  GtkAccelGroup *message1_menu_accels;
  GtkWidget *on1;
  GtkWidget *off1;
  GtkWidget *drawingarea1;
  GtkWidget *statusbar1;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  mainwin = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (mainwin, "mainwin");
  gtk_object_set_data (GTK_OBJECT (mainwin), "mainwin", mainwin);
  gtk_widget_set_usize (mainwin, 640, 528);
  gtk_widget_set_events (mainwin, GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK | GDK_KEY_PRESS_MASK);
  gtk_window_set_title (GTK_WINDOW (mainwin), "sprite sample 2");
  gtk_window_set_policy (GTK_WINDOW (mainwin), FALSE, FALSE, FALSE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (mainwin), vbox1);

  filemenu = gtk_menu_bar_new ();
  gtk_widget_set_name (filemenu, "filemenu");
  gtk_widget_ref (filemenu);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "filemenu", filemenu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (filemenu);
  gtk_box_pack_start (GTK_BOX (vbox1), filemenu, FALSE, FALSE, 0);
  gtk_menu_bar_set_shadow_type (GTK_MENU_BAR (filemenu), GTK_SHADOW_ETCHED_IN);

  item1 = gtk_menu_item_new_with_label ("File");
  gtk_widget_set_name (item1, "item1");
  gtk_widget_ref (item1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "item1", item1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (item1);
  gtk_container_add (GTK_CONTAINER (filemenu), item1);

  item1_menu = gtk_menu_new ();
  gtk_widget_set_name (item1_menu, "item1_menu");
  gtk_widget_ref (item1_menu);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "item1_menu", item1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (item1), item1_menu);
  item1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (item1_menu));

  gamequit = gtk_menu_item_new_with_label ("quit");
  gtk_widget_set_name (gamequit, "gamequit");
  gtk_widget_ref (gamequit);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "gamequit", gamequit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (gamequit);
  gtk_container_add (GTK_CONTAINER (item1_menu), gamequit);
  gtk_widget_add_accelerator (gamequit, "activate", accel_group,
                              GDK_Q, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  petal1 = gtk_menu_item_new_with_label ("Petal");
  gtk_widget_set_name (petal1, "petal1");
  gtk_widget_ref (petal1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "petal1", petal1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (petal1);
  gtk_container_add (GTK_CONTAINER (filemenu), petal1);

  petal1_menu = gtk_menu_new ();
  gtk_widget_set_name (petal1_menu, "petal1_menu");
  gtk_widget_ref (petal1_menu);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "petal1_menu", petal1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (petal1), petal1_menu);
  petal1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (petal1_menu));

  _10 = gtk_menu_item_new_with_label ("10");
  gtk_widget_set_name (_10, "_10");
  gtk_widget_ref (_10);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "_10", _10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (_10);
  gtk_container_add (GTK_CONTAINER (petal1_menu), _10);

  _25 = gtk_menu_item_new_with_label ("25");
  gtk_widget_set_name (_25, "_25");
  gtk_widget_ref (_25);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "_25", _25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (_25);
  gtk_container_add (GTK_CONTAINER (petal1_menu), _25);

  _50 = gtk_menu_item_new_with_label ("50");
  gtk_widget_set_name (_50, "_50");
  gtk_widget_ref (_50);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "_50", _50,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (_50);
  gtk_container_add (GTK_CONTAINER (petal1_menu), _50);

  _100 = gtk_menu_item_new_with_label ("100");
  gtk_widget_set_name (_100, "_100");
  gtk_widget_ref (_100);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "_100", _100,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (_100);
  gtk_container_add (GTK_CONTAINER (petal1_menu), _100);

  position1 = gtk_menu_item_new_with_label ("Position");
  gtk_widget_set_name (position1, "position1");
  gtk_widget_ref (position1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "position1", position1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (position1);
  gtk_container_add (GTK_CONTAINER (filemenu), position1);

  position1_menu = gtk_menu_new ();
  gtk_widget_set_name (position1_menu, "position1_menu");
  gtk_widget_ref (position1_menu);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "position1_menu", position1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (position1), position1_menu);
  position1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (position1_menu));

  right1 = gtk_menu_item_new_with_label ("right");
  gtk_widget_set_name (right1, "right1");
  gtk_widget_ref (right1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "right1", right1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (right1);
  gtk_container_add (GTK_CONTAINER (position1_menu), right1);

  left1 = gtk_menu_item_new_with_label ("left");
  gtk_widget_set_name (left1, "left1");
  gtk_widget_ref (left1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "left1", left1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (left1);
  gtk_container_add (GTK_CONTAINER (position1_menu), left1);

  message1 = gtk_menu_item_new_with_label ("Message");
  gtk_widget_set_name (message1, "message1");
  gtk_widget_ref (message1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "message1", message1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (message1);
  gtk_container_add (GTK_CONTAINER (filemenu), message1);

  message1_menu = gtk_menu_new ();
  gtk_widget_set_name (message1_menu, "message1_menu");
  gtk_widget_ref (message1_menu);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "message1_menu", message1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (message1), message1_menu);
  message1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (message1_menu));

  on1 = gtk_menu_item_new_with_label ("On");
  gtk_widget_set_name (on1, "on1");
  gtk_widget_ref (on1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "on1", on1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (on1);
  gtk_container_add (GTK_CONTAINER (message1_menu), on1);

  off1 = gtk_menu_item_new_with_label ("Off");
  gtk_widget_set_name (off1, "off1");
  gtk_widget_ref (off1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "off1", off1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (off1);
  gtk_container_add (GTK_CONTAINER (message1_menu), off1);

  drawingarea1 = gtk_drawing_area_new ();
  gtk_widget_set_name (drawingarea1, "lm_spr2_demo");
  gtk_widget_ref (drawingarea1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "lm_spr2_demo", drawingarea1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (drawingarea1);
  gtk_box_pack_start (GTK_BOX (vbox1), drawingarea1, TRUE, TRUE, 0);

  statusbar1 = gtk_statusbar_new ();
  gtk_widget_set_name (statusbar1, "statusbar1");
  gtk_widget_ref (statusbar1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "statusbar1", statusbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (statusbar1);
  gtk_box_pack_end (GTK_BOX (vbox1), statusbar1, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (mainwin), "destroy",
                      GTK_SIGNAL_FUNC (on_mainwin_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (item1), "activate",
                      GTK_SIGNAL_FUNC (on_item1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (gamequit), "activate",
                      GTK_SIGNAL_FUNC (on_gamequit_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (_10), "activate",
                      GTK_SIGNAL_FUNC (on_10_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (_25), "activate",
                      GTK_SIGNAL_FUNC (on_25_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (_50), "activate",
                      GTK_SIGNAL_FUNC (on_50_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (_100), "activate",
                      GTK_SIGNAL_FUNC (on_100_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (right1), "activate",
                      GTK_SIGNAL_FUNC (on_right1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (left1), "activate",
                      GTK_SIGNAL_FUNC (on_left1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (on1), "activate",
                      GTK_SIGNAL_FUNC (on_on1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (off1), "activate",
                      GTK_SIGNAL_FUNC (on_off1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (drawingarea1), "expose_event",
                      GTK_SIGNAL_FUNC (on_drawingarea1_expose_event),
                      NULL);

  gtk_window_add_accel_group (GTK_WINDOW (mainwin), accel_group);

  return mainwin;
}

