/* =====================================================================

   LiMo - Liblary Header
      Graphic Display System.  - ̴ȥ֥ɽ

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

#ifndef RR_SCREEN

#define RR_SCREEN

#include <gtk/gtk.h>
#include <gdk/gdkx.h>

/* -------------------------------------------------------------
 --- Structure
-------------------------------------------------------------- */

typedef struct _RRSprite RRSprite;

struct _RRSprite
{
  gboolean  sw;              /* ɽå */
  gboolean  mask_offset;     /* ޥox, oy˴ط뤫 */
  GdkPixmap  *objmap;        /* ɽObjΥޥå */
  GdkBitmap  *objmask;       /* Objȴ */
  gint  x, y;                /* ꡼ؤɽ */
  gint  w, h;                /* ɽObjΥ */
  gint  ox, oy;              /* objmapǤΥƥ㡼ɸ */
  gint  offset_x, offset_y;  /* ֥濴κɸեå */
};

/* -------------------------------------------------------------
 --- Extern
-------------------------------------------------------------- */
#ifdef __cplusplus
extern              "C"
{
#endif                          /* __cplusplus */

void       RRScreenInit(GtkWidget*, GtkWidget*, gint, gint, gboolean);
void       RRScreenInitRoot(GdkWindow*, gint, gint, gboolean);
void       RRScreenFree(void);
gint       RRScreenSwitch(void);
gint       RRScreenSwitchRoot(void);
gboolean   RRScreenRedraw(GtkWidget*, GdkEventExpose*, gpointer);
gint       RRScreenBufNum(void);
GdkPixmap *RRScreenBuffer(void);
GtkWidget *RRScreenCanvas(void);
GtkWidget *RRScreenWindow(void);
gboolean   RRScreenIsRoot(void);
GdkWindow *RRScreenRoot(void);
void       RRScreenWinShape(GdkBitmap*);
void       RRScreenSetPalette(GdkColormap*, gint);
void       RRScreenGCColor(gint, gint, gint);
GdkGC     *RRScreenGCGet(void);
void       RRScreenClear(gint, gint, gint);
void       RRScreenFontSetDirect(GdkFont*);
void       RRScreenFontSetInit(gchar*);
void       RRScreenFontInit(gchar*);
void       RRScreenFontLocate(gint, gint);
void       RRScreenFontSize(gchar*, gint*, gint*);
void       RRScreenFontPrint(const gchar *);
void       RRScreenFontPrintDirect(GdkPixmap* ,const gchar*);
void       RRScreenPutPixmap(GdkPixmap*, gint, gint);
void       RRScreenObjPut(RRSprite *);
void       RRScreenObjPutDirect(GdkPixmap *, RRSprite *);
void       RRScreenPoint(gint, gint);
void       RRScreenLine(gint, gint, gint, gint);
void       RRScreenRectangle(gint, gint, gint, gint, gint);
GtkWidget *RRGetParts(GtkWidget *, gchar *);


#ifdef __cplusplus
}
#endif                          /* __cplusplus */

#endif



